summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorAbdulla Abdullaev <james.purnell@tmail.link>2023-01-18 15:13:18 +0500
committerAbdulla Abdullaev <james.purnell@tmail.link>2023-01-18 15:13:18 +0500
commit84031227eafb5cdcca859b029cd9f56b71d96672 (patch)
tree452cda49a8379d1633b5c950e802e6cfb9ff344c
Init
-rw-r--r--mvnw316
-rw-r--r--mvnw.cmd188
-rw-r--r--pom.xml74
-rw-r--r--src/main/java/com/mavlushechka/notaryqueue/NotaryQueueApplication.java83
-rw-r--r--src/main/java/com/mavlushechka/notaryqueue/controller/HelperController.java189
-rw-r--r--src/main/java/com/mavlushechka/notaryqueue/controller/MainController.java27
-rw-r--r--src/main/java/com/mavlushechka/notaryqueue/model/Client.java128
-rw-r--r--src/main/java/com/mavlushechka/notaryqueue/model/Role.java7
-rw-r--r--src/main/java/com/mavlushechka/notaryqueue/model/Status.java7
-rw-r--r--src/main/java/com/mavlushechka/notaryqueue/model/User.java23
-rw-r--r--src/main/java/com/mavlushechka/notaryqueue/util/Socket.java75
-rw-r--r--src/main/java/module-info.java16
-rw-r--r--src/main/resources/com/mavlushechka/notaryqueue/helper.fxml14
-rw-r--r--src/main/resources/com/mavlushechka/notaryqueue/main.fxml22
-rw-r--r--src/main/resources/com/mavlushechka/notaryqueue/monitor.fxml29
-rw-r--r--src/main/resources/com/mavlushechka/notaryqueue/notary.fxml6
16 files changed, 1204 insertions, 0 deletions
diff --git a/mvnw b/mvnw
new file mode 100644
index 0000000..8a8fb22
--- /dev/null
+++ b/mvnw
@@ -0,0 +1,316 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+ if [ -f /usr/local/etc/mavenrc ] ; then
+ . /usr/local/etc/mavenrc
+ fi
+
+ if [ -f /etc/mavenrc ] ; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ] ; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+ CYGWIN*) cygwin=true ;;
+ MINGW*) mingw=true;;
+ Darwin*) darwin=true
+ # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+ # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+ if [ -z "$JAVA_HOME" ]; then
+ if [ -x "/usr/libexec/java_home" ]; then
+ export JAVA_HOME="`/usr/libexec/java_home`"
+ else
+ export JAVA_HOME="/Library/Java/Home"
+ fi
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+ if [ -r /etc/gentoo-release ] ; then
+ JAVA_HOME=`java-config --jre-home`
+ fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ] ; do
+ ls=`ls -ld "$PRG"`
+ link=`expr "$ls" : '.*-> \(.*\)$'`
+ if expr "$link" : '/.*' > /dev/null; then
+ PRG="$link"
+ else
+ PRG="`dirname "$PRG"`/$link"
+ fi
+ done
+
+ saveddir=`pwd`
+
+ M2_HOME=`dirname "$PRG"`/..
+
+ # make it fully qualified
+ M2_HOME=`cd "$M2_HOME" && pwd`
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --unix "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Mingw, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="`(cd "$M2_HOME"; pwd)`"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="`which javac`"
+ if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=`which readlink`
+ if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+ if $darwin ; then
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+ else
+ javaExecutable="`readlink -f \"$javaExecutable\"`"
+ fi
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+ if [ -n "$JAVA_HOME" ] ; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="`\\unset -f command; \\command -v java`"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+ if [ -z "$1" ]
+ then
+ echo "Path not specified to find_maven_basedir"
+ return 1
+ fi
+
+ basedir="$1"
+ wdir="$1"
+ while [ "$wdir" != '/' ] ; do
+ if [ -d "$wdir"/.mvn ] ; then
+ basedir=$wdir
+ break
+ fi
+ # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+ if [ -d "${wdir}" ]; then
+ wdir=`cd "$wdir/.."; pwd`
+ fi
+ # end of workaround
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' < "$1")"
+ fi
+}
+
+BASE_DIR=`find_maven_basedir "$(pwd)"`
+if [ -z "$BASE_DIR" ]; then
+ exit 1;
+fi
+
+##########################################################################################
+# Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+# This allows using the maven wrapper in projects that prohibit checking in binary data.
+##########################################################################################
+if [ -r "$BASE_DIR/.mvn/wrapper/maven-wrapper.jar" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found .mvn/wrapper/maven-wrapper.jar"
+ fi
+else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Couldn't find .mvn/wrapper/maven-wrapper.jar, downloading it ..."
+ fi
+ if [ -n "$MVNW_REPOURL" ]; then
+ jarUrl="$MVNW_REPOURL/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ else
+ jarUrl="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ fi
+ while IFS="=" read key value; do
+ case "$key" in (wrapperUrl) jarUrl="$value"; break ;;
+ esac
+ done < "$BASE_DIR/.mvn/wrapper/maven-wrapper.properties"
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Downloading from: $jarUrl"
+ fi
+ wrapperJarPath="$BASE_DIR/.mvn/wrapper/maven-wrapper.jar"
+ if $cygwin; then
+ wrapperJarPath=`cygpath --path --windows "$wrapperJarPath"`
+ fi
+
+ if command -v wget > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found wget ... using wget"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ wget "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ else
+ wget --http-user=$MVNW_USERNAME --http-password=$MVNW_PASSWORD "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ fi
+ elif command -v curl > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found curl ... using curl"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ curl -o "$wrapperJarPath" "$jarUrl" -f
+ else
+ curl --user $MVNW_USERNAME:$MVNW_PASSWORD -o "$wrapperJarPath" "$jarUrl" -f
+ fi
+
+ else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Falling back to using Java to download"
+ fi
+ javaClass="$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.java"
+ # For Cygwin, switch paths to Windows format before running javac
+ if $cygwin; then
+ javaClass=`cygpath --path --windows "$javaClass"`
+ fi
+ if [ -e "$javaClass" ]; then
+ if [ ! -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Compiling MavenWrapperDownloader.java ..."
+ fi
+ # Compiling the Java class
+ ("$JAVA_HOME/bin/javac" "$javaClass")
+ fi
+ if [ -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ # Running the downloader
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Running MavenWrapperDownloader.java ..."
+ fi
+ ("$JAVA_HOME/bin/java" -cp .mvn/wrapper MavenWrapperDownloader "$MAVEN_PROJECTBASEDIR")
+ fi
+ fi
+ fi
+fi
+##########################################################################################
+# End of extension
+##########################################################################################
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+if [ "$MVNW_VERBOSE" = true ]; then
+ echo $MAVEN_PROJECTBASEDIR
+fi
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --path --windows "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+ [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+ MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
+fi
+
+# Provide a "standardized" way to retrieve the CLI args that will
+# work with both Windows and non-Windows executions.
+MAVEN_CMD_LINE_ARGS="$MAVEN_CONFIG $@"
+export MAVEN_CMD_LINE_ARGS
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ $MAVEN_DEBUG_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" \
+ "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"
diff --git a/mvnw.cmd b/mvnw.cmd
new file mode 100644
index 0000000..1d8ab01
--- /dev/null
+++ b/mvnw.cmd
@@ -0,0 +1,188 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM https://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a keystroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM set title of command window
+title %0
+@REM enable echoing by setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_pre.bat" call "%USERPROFILE%\mavenrc_pre.bat" %*
+if exist "%USERPROFILE%\mavenrc_pre.cmd" call "%USERPROFILE%\mavenrc_pre.cmd" %*
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+set DOWNLOAD_URL="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+
+FOR /F "usebackq tokens=1,2 delims==" %%A IN ("%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.properties") DO (
+ IF "%%A"=="wrapperUrl" SET DOWNLOAD_URL=%%B
+)
+
+@REM Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+@REM This allows using the maven wrapper in projects that prohibit checking in binary data.
+if exist %WRAPPER_JAR% (
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Found %WRAPPER_JAR%
+ )
+) else (
+ if not "%MVNW_REPOURL%" == "" (
+ SET DOWNLOAD_URL="%MVNW_REPOURL%/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ )
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Couldn't find %WRAPPER_JAR%, downloading it ...
+ echo Downloading from: %DOWNLOAD_URL%
+ )
+
+ powershell -Command "&{"^
+ "$webclient = new-object System.Net.WebClient;"^
+ "if (-not ([string]::IsNullOrEmpty('%MVNW_USERNAME%') -and [string]::IsNullOrEmpty('%MVNW_PASSWORD%'))) {"^
+ "$webclient.Credentials = new-object System.Net.NetworkCredential('%MVNW_USERNAME%', '%MVNW_PASSWORD%');"^
+ "}"^
+ "[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12; $webclient.DownloadFile('%DOWNLOAD_URL%', '%WRAPPER_JAR%')"^
+ "}"
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Finished downloading %WRAPPER_JAR%
+ )
+)
+@REM End of extension
+
+@REM Provide a "standardized" way to retrieve the CLI args that will
+@REM work with both Windows and non-Windows executions.
+set MAVEN_CMD_LINE_ARGS=%*
+
+%MAVEN_JAVA_EXE% ^
+ %JVM_CONFIG_MAVEN_PROPS% ^
+ %MAVEN_OPTS% ^
+ %MAVEN_DEBUG_OPTS% ^
+ -classpath %WRAPPER_JAR% ^
+ "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" ^
+ %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%"=="" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_post.bat" call "%USERPROFILE%\mavenrc_post.bat"
+if exist "%USERPROFILE%\mavenrc_post.cmd" call "%USERPROFILE%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%"=="on" pause
+
+if "%MAVEN_TERMINATE_CMD%"=="on" exit %ERROR_CODE%
+
+cmd /C exit /B %ERROR_CODE%
diff --git a/pom.xml b/pom.xml
new file mode 100644
index 0000000..ecb39d1
--- /dev/null
+++ b/pom.xml
@@ -0,0 +1,74 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<project xmlns="http://maven.apache.org/POM/4.0.0"
+ xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+ xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 https://maven.apache.org/xsd/maven-4.0.0.xsd">
+ <modelVersion>4.0.0</modelVersion>
+
+ <groupId>com.mavlushechka</groupId>
+ <artifactId>notaryqueue</artifactId>
+ <version>1.0-SNAPSHOT</version>
+ <name>Notary Queue</name>
+
+ <properties>
+ <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
+ <junit.version>5.9.0</junit.version>
+ </properties>
+
+ <dependencies>
+ <dependency>
+ <groupId>org.openjfx</groupId>
+ <artifactId>javafx-controls</artifactId>
+ <version>18.0.2</version>
+ </dependency>
+ <dependency>
+ <groupId>org.openjfx</groupId>
+ <artifactId>javafx-fxml</artifactId>
+ <version>18.0.2</version>
+ </dependency>
+
+ <dependency>
+ <groupId>com.fasterxml.jackson.core</groupId>
+ <artifactId>jackson-databind</artifactId>
+ <version>2.13.4</version>
+ </dependency>
+ <dependency>
+ <groupId>com.fasterxml.jackson.datatype</groupId>
+ <artifactId>jackson-datatype-jsr310</artifactId>
+ <version>2.13.4</version>
+ </dependency>
+ </dependencies>
+
+ <build>
+ <plugins>
+ <plugin>
+ <groupId>org.apache.maven.plugins</groupId>
+ <artifactId>maven-compiler-plugin</artifactId>
+ <version>3.10.1</version>
+ <configuration>
+ <source>18</source>
+ <target>18</target>
+ </configuration>
+ </plugin>
+ <plugin>
+ <groupId>org.openjfx</groupId>
+ <artifactId>javafx-maven-plugin</artifactId>
+ <version>0.0.8</version>
+ <executions>
+ <execution>
+ <!-- Default configuration for running with: mvn clean javafx:run -->
+ <id>default-cli</id>
+ <configuration>
+ <mainClass>com.mavlushechka.notaryqueue.NotaryQueueApplication</mainClass>
+ <launcher>app</launcher>
+ <jlinkZipName>app</jlinkZipName>
+ <jlinkImageName>app</jlinkImageName>
+ <noManPages>true</noManPages>
+ <stripDebug>true</stripDebug>
+ <noHeaderFiles>true</noHeaderFiles>
+ </configuration>
+ </execution>
+ </executions>
+ </plugin>
+ </plugins>
+ </build>
+</project> \ No newline at end of file
diff --git a/src/main/java/com/mavlushechka/notaryqueue/NotaryQueueApplication.java b/src/main/java/com/mavlushechka/notaryqueue/NotaryQueueApplication.java
new file mode 100644
index 0000000..29605ea
--- /dev/null
+++ b/src/main/java/com/mavlushechka/notaryqueue/NotaryQueueApplication.java
@@ -0,0 +1,83 @@
+package com.mavlushechka.notaryqueue;
+
+import com.mavlushechka.notaryqueue.controller.HelperController;
+import javafx.application.Application;
+import javafx.fxml.FXMLLoader;
+import javafx.fxml.JavaFXBuilderFactory;
+import javafx.scene.Parent;
+import javafx.scene.Scene;
+import javafx.stage.Stage;
+
+import java.io.IOException;
+import java.net.URL;
+import java.util.Objects;
+
+public class NotaryQueueApplication extends Application {
+
+
+ public static NotaryQueueApplication instance;
+ private Stage stage;
+
+
+ public static void main(String[] args) {
+ launch();
+ }
+
+ public NotaryQueueApplication() {
+ instance = this;
+ }
+
+ @Override
+ public void start(Stage stage) throws IOException {
+ FXMLLoader fxmlLoader = new FXMLLoader(NotaryQueueApplication.class.getResource("main.fxml"));
+ Scene scene = new Scene(fxmlLoader.load(), 600, 400);
+
+ stage.setScene(scene);
+ stage.show();
+ this.stage = stage;
+ }
+
+ public void setNotaryScene() {
+ try {
+ setScene(NotaryQueueApplication.class.getResource("notary.fxml"));
+ } catch (IOException ioException) {
+ throw new RuntimeException(ioException);
+ }
+ }
+
+ public void setHelperScene() {
+ try {
+ setScene(NotaryQueueApplication.class.getResource("helper.fxml"));
+ } catch (IOException ioException) {
+ throw new RuntimeException(ioException);
+ }
+ HelperController.instance.setContextMenuToClientListViews();
+ HelperController.instance.loadClientsToListViews();
+ HelperController.instance.receiveUpdates();
+ }
+
+ public void setMonitorScene() {
+ try {
+ setScene(NotaryQueueApplication.class.getResource("monitor.fxml"));
+ } catch (IOException ioException) {
+ throw new RuntimeException(ioException);
+ }
+ HelperController.instance.isMonitorScene = true;
+ HelperController.instance.loadClientsToListViews();
+ HelperController.instance.receiveUpdates();
+ }
+
+ private void setScene(URL fxml) throws IOException {
+ Parent parent = FXMLLoader.load(Objects.requireNonNull(fxml), null, new JavaFXBuilderFactory());
+ Scene scene = stage.getScene();
+
+ if (scene == null) {
+ scene = new Scene(parent, 1280, 720);
+ stage.setScene(scene);
+ } else {
+ stage.getScene().setRoot(parent);
+ }
+ stage.sizeToScene();
+ }
+
+} \ No newline at end of file
diff --git a/src/main/java/com/mavlushechka/notaryqueue/controller/HelperController.java b/src/main/java/com/mavlushechka/notaryqueue/controller/HelperController.java
new file mode 100644
index 0000000..13d1aa8
--- /dev/null
+++ b/src/main/java/com/mavlushechka/notaryqueue/controller/HelperController.java
@@ -0,0 +1,189 @@
+package com.mavlushechka.notaryqueue.controller;
+
+import com.mavlushechka.notaryqueue.util.Socket;
+import com.mavlushechka.notaryqueue.model.Client;
+import com.mavlushechka.notaryqueue.model.Status;
+import javafx.application.Platform;
+import javafx.collections.ObservableList;
+import javafx.fxml.FXML;
+import javafx.scene.control.*;
+
+import java.time.LocalTime;
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Optional;
+
+public class HelperController {
+
+
+ public static HelperController instance;
+ public boolean isMonitorScene;
+ @FXML
+ private ListView<Client> waitingClients = new ListView<>();
+ @FXML
+ private ListView<Client> processingClients = new ListView<>();
+ @FXML
+ private ListView<Client> readyClients = new ListView<>();
+ private final ArrayList<Client> removedClients = new ArrayList<>();
+
+
+ public HelperController() {
+ instance = this;
+ }
+
+ public void setContextMenuToClientListViews() {
+ MenuItem addClientOnProcessingClientsListView = new MenuItem("Qoshish");
+ addClientOnProcessingClientsListView.setOnAction(event -> showAddClientDialogs());
+
+ MenuItem waitClientOnProcessingClients = new MenuItem("Kutilmoqda");
+ waitClientOnProcessingClients.setOnAction(event -> setSelectedClientStatus(processingClients, Status.WAITING));
+ MenuItem waitClientOnReadyClients = new MenuItem("Kutilmoqda");
+ waitClientOnReadyClients.setOnAction(event -> setSelectedClientStatus(readyClients, Status.WAITING));
+
+ MenuItem processClientOnWaitingClients = new MenuItem("Bajarilmoqda");
+ processClientOnWaitingClients.setOnAction(event -> setSelectedClientStatus(waitingClients, Status.PROCESSING));
+ MenuItem processClientOnReadyClients = new MenuItem("Bajarilmoqda");
+ processClientOnReadyClients.setOnAction(event -> setSelectedClientStatus(readyClients, Status.PROCESSING));
+
+ MenuItem readyClientOnWaitingClients = new MenuItem("Tayyor");
+ readyClientOnWaitingClients.setOnAction(event -> setSelectedClientStatus(waitingClients, Status.READY));
+ MenuItem readyClientOnProcessingClients = new MenuItem("Tayyor");
+ readyClientOnProcessingClients.setOnAction(event -> setSelectedClientStatus(processingClients, Status.READY));
+
+ MenuItem removeClientOnWaitingClients = new MenuItem("O'chirish");
+ removeClientOnWaitingClients.setOnAction(event -> showRemoveSelectedClientDialog(waitingClients));
+ MenuItem removeClientOnProcessingClients = new MenuItem("O'chirish");
+ removeClientOnProcessingClients.setOnAction(event -> showRemoveSelectedClientDialog(processingClients));
+ MenuItem removeClientOnReadyClients = new MenuItem("O'chirish");
+ removeClientOnReadyClients.setOnAction(event -> showRemoveSelectedClientDialog(readyClients));
+
+ waitingClients.setContextMenu(new ContextMenu(processClientOnWaitingClients, readyClientOnWaitingClients, removeClientOnWaitingClients));
+ processingClients.setContextMenu(new ContextMenu(addClientOnProcessingClientsListView, waitClientOnProcessingClients, readyClientOnProcessingClients, removeClientOnProcessingClients));
+ readyClients.setContextMenu(new ContextMenu(waitClientOnReadyClients, processClientOnReadyClients, removeClientOnReadyClients));
+ }
+
+ public void loadClientsToListViews() {
+// try (ObjectInputStream objectInputStreamOfWaitingClients = new ObjectInputStream(new FileInputStream("target/serialization/waitingClients"))) {
+// ((ArrayList<Client>) objectInputStreamOfWaitingClients.readObject()).forEach(this::addClient);
+// Platform.runLater(() -> System.out.println("Waiting clients are loaded : " + waitingClients.getItems()));
+// } catch (IOException | ClassNotFoundException ignored) {
+// System.out.println("Waiting clients are not loaded.");
+// }
+// try (ObjectInputStream objectInputStreamOfProcessingClients = new ObjectInputStream(new FileInputStream("target/serialization/processingClients"))) {
+// ((ArrayList<Client>) objectInputStreamOfProcessingClients.readObject()).forEach(this::addClient);
+// Platform.runLater(() -> System.out.println("Processing clients are loaded : " + processingClients.getItems()));
+// } catch (IOException | ClassNotFoundException ignored) {
+// System.out.println("Processing clients are not loaded.");
+// }
+// try (ObjectInputStream objectInputStreamOfReadyClients = new ObjectInputStream(new FileInputStream("target/serialization/readyClients"))) {
+// ((ArrayList<Client>) objectInputStreamOfReadyClients.readObject()).forEach(this::addClient);
+// Platform.runLater(() -> System.out.println("Ready clients are loaded : " + readyClients.getItems()));
+// } catch (IOException | ClassNotFoundException ignored) {
+// System.out.println("Ready clients are not loaded.");
+// }
+ }
+
+ public void receiveUpdates() {
+ new Thread(() -> {
+ while (true) {
+ removeClient(Socket.receiveDeletedClient());
+ }
+ }).start();
+ new Thread(() -> {
+ while (true) {
+ addClient(Socket.receiveNewClient());
+ }
+ }).start();
+ }
+
+ public void addClient(Client client) {
+ ObservableList<Client> observableList = null;
+ switch (client.getStatus()) {
+ case WAITING -> observableList = waitingClients.getItems();
+ case PROCESSING -> observableList = processingClients.getItems();
+ case READY -> observableList = readyClients.getItems();
+ }
+
+ if (isMonitorScene) {
+ client.setClientDocumentTypeVisible(false);
+ client.setLocalTimeVisible(false);
+ }
+
+ ObservableList<Client> finalObservableList = observableList;
+ Platform.runLater(() -> {
+ finalObservableList.add(client);
+ System.out.println(client + " is added to " + client.getStatus().toString().toLowerCase() + " list.");
+ });
+ }
+
+ public void removeClient(Client client) {
+ ObservableList<Client> observableList = null;
+ switch (client.getStatus()) {
+ case WAITING -> observableList = waitingClients.getItems();
+ case PROCESSING -> observableList = processingClients.getItems();
+ case READY -> observableList = readyClients.getItems();
+ }
+
+ if (isMonitorScene) {
+ client.setClientDocumentTypeVisible(false);
+ client.setLocalTimeVisible(false);
+ }
+
+ ObservableList<Client> finalObservableList = observableList;
+ Platform.runLater(() -> {
+ boolean isRemoved = finalObservableList.remove(client);
+ System.out.println(client + " is" + (isRemoved ? "" : " not") + " removed from " + client.getStatus().toString().toLowerCase() + " list.");
+ if (isRemoved) {
+ removedClients.add(client);
+ }
+ });
+ }
+
+ public void showAddClientDialogs() {
+ TextInputDialog textInputDialog = new TextInputDialog();
+ textInputDialog.setHeaderText("Mijozni ismi");
+ Optional<String> clientName = textInputDialog.showAndWait();
+
+ List<String> documents = List.of("Avto oldi-sotdi (hadya)", "Avto ishonchnoma", "Uy oldi-sotdi (hadya)", "Ipoteka, garov", "Ijara", "Meros vasiyatnoma", "Boshka ishonchnoma", "Boshka turdagi xarakatlar");
+ ChoiceDialog<String> choiceDialog = new ChoiceDialog<>(documents.get(0), documents);
+ choiceDialog.setHeaderText("Document");
+
+ Optional<String> clientDocument = choiceDialog.showAndWait();
+ Client client = new Client(String.format("%02d", getNumberOfClients() + 1), clientName.orElse("Error"), Status.PROCESSING, clientDocument.orElse("Error"), true, LocalTime.now(), true);
+ Socket.sendNewClient(client);
+ }
+
+ public void showRemoveSelectedClientDialog(ListView<Client> clientsListView) {
+ Client client = clientsListView.getSelectionModel().getSelectedItem();
+ if (client == null) {
+ throw new IllegalStateException("Client is not selected");
+ }
+
+ Dialog<ButtonType> dialog = new Dialog<>();
+ dialog.setHeaderText(client.name + "'ni oʻchirib tashlamoqchimisiz?");
+ dialog.getDialogPane().getButtonTypes().add(new ButtonType("Yo'q", ButtonBar.ButtonData.NO));
+ dialog.getDialogPane().getButtonTypes().add(new ButtonType("Ha", ButtonBar.ButtonData.YES));
+
+ Optional<ButtonType> answer = dialog.showAndWait();
+ if ("Y".equals(answer.orElse(new ButtonType("Error")).getButtonData().getTypeCode())) {
+ Socket.sendDeletedClient(client);
+ }
+ }
+
+ public int getNumberOfClients() {
+ return waitingClients.getItems().size() + processingClients.getItems().size() + readyClients.getItems().size() + removedClients.size();
+ }
+
+ private void setSelectedClientStatus(ListView<Client> clientsListView, Status status) {
+ Client client = clientsListView.getSelectionModel().getSelectedItem();
+ if (client == null) {
+ throw new IllegalStateException("Client is not selected");
+ }
+ Socket.sendDeletedClient(client);
+
+ Client newClient = new Client(client);
+ newClient.setStatus(status);
+ Socket.sendNewClient(newClient);
+ }
+
+}
diff --git a/src/main/java/com/mavlushechka/notaryqueue/controller/MainController.java b/src/main/java/com/mavlushechka/notaryqueue/controller/MainController.java
new file mode 100644
index 0000000..3de4d36
--- /dev/null
+++ b/src/main/java/com/mavlushechka/notaryqueue/controller/MainController.java
@@ -0,0 +1,27 @@
+package com.mavlushechka.notaryqueue.controller;
+
+import com.mavlushechka.notaryqueue.NotaryQueueApplication;
+import javafx.fxml.FXML;
+
+public class MainController {
+
+ @FXML
+ private void onNotaryButtonClick() {
+ NotaryQueueApplication.instance.setNotaryScene();
+ }
+
+ @FXML
+ private void onHelperButtonClick() {
+ NotaryQueueApplication.instance.setHelperScene();
+ }
+
+ @FXML
+ private void onMonitorButtonClick() {
+ NotaryQueueApplication.instance.setMonitorScene();
+ }
+
+ @FXML
+ private void onTabletButtonClick() {
+ }
+
+} \ No newline at end of file
diff --git a/src/main/java/com/mavlushechka/notaryqueue/model/Client.java b/src/main/java/com/mavlushechka/notaryqueue/model/Client.java
new file mode 100644
index 0000000..25033d2
--- /dev/null
+++ b/src/main/java/com/mavlushechka/notaryqueue/model/Client.java
@@ -0,0 +1,128 @@
+package com.mavlushechka.notaryqueue.model;
+
+import java.io.Serializable;
+import java.time.LocalTime;
+import java.time.format.DateTimeFormatter;
+import java.util.Objects;
+
+public class Client implements Serializable {
+
+ public String numberInQueue;
+ public String name;
+ public LocalTime localTime;
+ public String clientDocumentType;
+ private Status status;
+ private boolean isClientDocumentTypeVisible;
+ private boolean isLocalTimeVisible;
+
+
+ public Client() {
+ }
+
+ public Client(Client client) {
+ this.numberInQueue = client.numberInQueue;
+ this.name = client.name;
+ this.status = client.status;
+ this.clientDocumentType = client.clientDocumentType;
+ this.isClientDocumentTypeVisible = client.isClientDocumentTypeVisible;
+ this.localTime = client.localTime;
+ this.isLocalTimeVisible = client.isLocalTimeVisible;
+ }
+
+ public Client(String numberInQueue, String name, Status status, String clientDocumentType, boolean isClientDocumentTypeVisible, LocalTime localTime, boolean isLocalTimeVisible) {
+ this.numberInQueue = numberInQueue;
+ this.name = name;
+ this.status = status;
+ this.clientDocumentType = clientDocumentType;
+ this.isClientDocumentTypeVisible = isClientDocumentTypeVisible;
+ this.localTime = localTime;
+ this.isLocalTimeVisible = isLocalTimeVisible;
+ }
+
+ public String getNumberInQueue() {
+ return numberInQueue;
+ }
+
+ public void setNumberInQueue(String numberInQueue) {
+ this.numberInQueue = numberInQueue;
+ }
+
+ public String getName() {
+ return name;
+ }
+
+ public void setName(String name) {
+ this.name = name;
+ }
+
+ public LocalTime getLocalTime() {
+ return localTime;
+ }
+
+ public void setLocalTime(LocalTime localTime) {
+ this.localTime = localTime;
+ }
+
+ public String getClientDocumentType() {
+ return clientDocumentType;
+ }
+
+ public void setClientDocumentType(String clientDocumentType) {
+ this.clientDocumentType = clientDocumentType;
+ }
+
+ public Status getStatus() {
+ return status;
+ }
+
+ public void setStatus(Status status) {
+ this.status = status;
+ }
+
+ public boolean isClientDocumentTypeVisible() {
+ return isClientDocumentTypeVisible;
+ }
+
+ public void setClientDocumentTypeVisible(boolean clientDocumentTypeVisible) {
+ isClientDocumentTypeVisible = clientDocumentTypeVisible;
+ }
+
+ public boolean isLocalTimeVisible() {
+ return isLocalTimeVisible;
+ }
+
+ public void setLocalTimeVisible(boolean localTimeVisible) {
+ isLocalTimeVisible = localTimeVisible;
+ }
+
+ @Override
+ public boolean equals(Object object) {
+ if (this == object) return true;
+ if (object == null || getClass() != object.getClass()) return false;
+ Client client = (Client) object;
+ return isClientDocumentTypeVisible == client.isClientDocumentTypeVisible && isLocalTimeVisible == client.isLocalTimeVisible && Objects.equals(numberInQueue, client.numberInQueue) && Objects.equals(name, client.name) && Objects.equals(localTime, client.localTime) && Objects.equals(clientDocumentType, client.clientDocumentType) && status == client.status;
+ }
+
+ @Override
+ public int hashCode() {
+ return Objects.hash(numberInQueue, name, localTime, clientDocumentType, status, isClientDocumentTypeVisible, isLocalTimeVisible);
+ }
+
+ @Override
+ public String toString() {
+ String string = numberInQueue + ". " + name;
+
+ if (isClientDocumentTypeVisible || isLocalTimeVisible) {
+ string += " (";
+ if (isClientDocumentTypeVisible) {
+ string += clientDocumentType;
+ }
+ if (isLocalTimeVisible) {
+ string += (isClientDocumentTypeVisible ? ", " : "") + localTime.format(DateTimeFormatter.ofPattern("hh:mm"));
+ }
+ string += ")";
+ }
+ return string;
+ }
+
+}
diff --git a/src/main/java/com/mavlushechka/notaryqueue/model/Role.java b/src/main/java/com/mavlushechka/notaryqueue/model/Role.java
new file mode 100644
index 0000000..351da70
--- /dev/null
+++ b/src/main/java/com/mavlushechka/notaryqueue/model/Role.java
@@ -0,0 +1,7 @@
+package com.mavlushechka.notaryqueue.model;
+
+public enum Role {
+
+ NOTARY, HELPER, TABLET, MONITOR
+
+}
diff --git a/src/main/java/com/mavlushechka/notaryqueue/model/Status.java b/src/main/java/com/mavlushechka/notaryqueue/model/Status.java
new file mode 100644
index 0000000..adef558
--- /dev/null
+++ b/src/main/java/com/mavlushechka/notaryqueue/model/Status.java
@@ -0,0 +1,7 @@
+package com.mavlushechka.notaryqueue.model;
+
+public enum Status {
+
+ WAITING, PROCESSING, READY
+
+}
diff --git a/src/main/java/com/mavlushechka/notaryqueue/model/User.java b/src/main/java/com/mavlushechka/notaryqueue/model/User.java
new file mode 100644
index 0000000..de7944e
--- /dev/null
+++ b/src/main/java/com/mavlushechka/notaryqueue/model/User.java
@@ -0,0 +1,23 @@
+package com.mavlushechka.notaryqueue.model;
+
+public class User {
+
+ private Role role;
+
+
+ public User() {
+ }
+
+ public User(Role role) {
+ this.role = role;
+ }
+
+ public Role getRole() {
+ return role;
+ }
+
+ public void setRole(Role role) {
+ this.role = role;
+ }
+
+}
diff --git a/src/main/java/com/mavlushechka/notaryqueue/util/Socket.java b/src/main/java/com/mavlushechka/notaryqueue/util/Socket.java
new file mode 100644
index 0000000..57bf6a1
--- /dev/null
+++ b/src/main/java/com/mavlushechka/notaryqueue/util/Socket.java
@@ -0,0 +1,75 @@
+package com.mavlushechka.notaryqueue.util;
+
+import com.fasterxml.jackson.databind.ObjectMapper;
+import com.fasterxml.jackson.datatype.jsr310.JavaTimeModule;
+import com.mavlushechka.notaryqueue.model.Client;
+
+import java.io.IOException;
+import java.net.*;
+
+public class Socket {
+
+
+ private static final MulticastSocket NEW_CLIENT_SOCKET;
+ public static final int NEW_CLIENT_PORT = 1024;
+ private static final InetSocketAddress NEW_CLIENT_SOCKET_ADDRESS = new InetSocketAddress("228.5.6.7", NEW_CLIENT_PORT);
+ private static final MulticastSocket DELETED_CLIENT_SOCKET;
+ public static final int DELETED_CLIENT_PORT = 1025;
+ private static final InetSocketAddress DELETED_CLIENT_SOCKET_ADDRESS = new InetSocketAddress("228.5.6.7", DELETED_CLIENT_PORT);
+ public static final byte[] BUFFER = new byte[1024];
+
+
+ static {
+ try {
+ NEW_CLIENT_SOCKET = new MulticastSocket(NEW_CLIENT_PORT);
+ NEW_CLIENT_SOCKET.joinGroup(NEW_CLIENT_SOCKET_ADDRESS, null);
+ DELETED_CLIENT_SOCKET = new MulticastSocket(DELETED_CLIENT_PORT);
+ DELETED_CLIENT_SOCKET.joinGroup(DELETED_CLIENT_SOCKET_ADDRESS, null);
+ } catch (IOException e) {
+ throw new RuntimeException(e);
+ }
+ }
+
+
+ public static void sendNewClient(Client client) {
+ send(client, NEW_CLIENT_SOCKET, NEW_CLIENT_SOCKET_ADDRESS, NEW_CLIENT_PORT);
+ }
+
+ public static void sendDeletedClient(Client client) {
+ send(client, DELETED_CLIENT_SOCKET, DELETED_CLIENT_SOCKET_ADDRESS, DELETED_CLIENT_PORT);
+ }
+
+ public static Client receiveNewClient() {
+ return receiveClient(NEW_CLIENT_SOCKET);
+ }
+
+ public static Client receiveDeletedClient() {
+ return receiveClient(DELETED_CLIENT_SOCKET);
+ }
+
+ private static void send(Client client, MulticastSocket multicastSocket, InetSocketAddress inetSocketAddress, int port) {
+ try {
+ multicastSocket.send(new DatagramPacket(new ObjectMapper().registerModule(new JavaTimeModule()).writeValueAsString(client).getBytes(), new ObjectMapper().registerModule(new JavaTimeModule()).writeValueAsString(client).getBytes().length, inetSocketAddress.getAddress(), port));
+ } catch (IOException ioException) {
+ ioException.printStackTrace();
+ }
+ }
+
+ private static Client receiveClient(MulticastSocket multicastSocket) {
+ Client client = null;
+
+ while (client == null) {
+ DatagramPacket datagramPacket = new DatagramPacket(BUFFER, BUFFER.length);
+
+ try {
+ multicastSocket.receive(datagramPacket);
+ client = new ObjectMapper().registerModule(new JavaTimeModule()).readValue(datagramPacket.getData(), Client.class);
+ System.out.println(client + " is received.");
+ } catch (IOException e) {
+ throw new RuntimeException(e);
+ }
+ }
+ return client;
+ }
+
+} \ No newline at end of file
diff --git a/src/main/java/module-info.java b/src/main/java/module-info.java
new file mode 100644
index 0000000..f2c0565
--- /dev/null
+++ b/src/main/java/module-info.java
@@ -0,0 +1,16 @@
+module com.mavlushechka.notaryqueue {
+ requires javafx.controls;
+ requires javafx.fxml;
+ requires com.fasterxml.jackson.databind;
+ requires com.fasterxml.jackson.datatype.jsr310;
+
+
+ opens com.mavlushechka.notaryqueue to javafx.fxml;
+ exports com.mavlushechka.notaryqueue;
+ exports com.mavlushechka.notaryqueue.model;
+ opens com.mavlushechka.notaryqueue.model to javafx.fxml;
+ exports com.mavlushechka.notaryqueue.controller;
+ opens com.mavlushechka.notaryqueue.controller to javafx.fxml;
+ exports com.mavlushechka.notaryqueue.util;
+ opens com.mavlushechka.notaryqueue.util to javafx.fxml;
+} \ No newline at end of file
diff --git a/src/main/resources/com/mavlushechka/notaryqueue/helper.fxml b/src/main/resources/com/mavlushechka/notaryqueue/helper.fxml
new file mode 100644
index 0000000..c9ac27c
--- /dev/null
+++ b/src/main/resources/com/mavlushechka/notaryqueue/helper.fxml
@@ -0,0 +1,14 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<?import javafx.scene.control.ListView?>
+<?import javafx.scene.layout.AnchorPane?>
+<?import javafx.scene.text.Text?>
+
+<AnchorPane maxHeight="-Infinity" maxWidth="-Infinity" minHeight="-Infinity" minWidth="-Infinity" prefHeight="400.0" prefWidth="600.0" xmlns="http://javafx.com/javafx/18" xmlns:fx="http://javafx.com/fxml/1" fx:controller="com.mavlushechka.notaryqueue.controller.HelperController">
+ <ListView fx:id="waitingClients" layoutX="15.0" layoutY="30.0" prefHeight="275.0" prefWidth="175.0" />
+ <ListView fx:id="processingClients" layoutX="215.0" layoutY="30.0" prefHeight="275.0" prefWidth="175.0" />
+ <ListView fx:id="readyClients" layoutX="415.0" layoutY="30.0" prefHeight="275.0" prefWidth="175.0" />
+ <Text layoutX="67.0" layoutY="28.0" strokeType="OUTSIDE" strokeWidth="0.0" text="Kutilmoqda" />
+ <Text layoutX="259.0" layoutY="28.0" strokeType="OUTSIDE" strokeWidth="0.0" text="Bajarilmoqda" />
+ <Text layoutX="482.0" layoutY="28.0" strokeType="OUTSIDE" strokeWidth="0.0" text="Tayyor" />
+</AnchorPane>
diff --git a/src/main/resources/com/mavlushechka/notaryqueue/main.fxml b/src/main/resources/com/mavlushechka/notaryqueue/main.fxml
new file mode 100644
index 0000000..b3529b0
--- /dev/null
+++ b/src/main/resources/com/mavlushechka/notaryqueue/main.fxml
@@ -0,0 +1,22 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<?import javafx.scene.control.Button?>
+<?import javafx.scene.layout.AnchorPane?>
+<?import javafx.scene.layout.VBox?>
+<?import javafx.scene.text.Font?>
+<?import javafx.scene.text.Text?>
+
+<AnchorPane maxHeight="-Infinity" maxWidth="-Infinity" minHeight="-Infinity" minWidth="-Infinity" prefHeight="400.0" prefWidth="600.0" xmlns="http://javafx.com/javafx/18"
+ xmlns:fx="http://javafx.com/fxml/1" fx:controller="com.mavlushechka.notaryqueue.controller.MainController">
+ <Text layoutX="238.0" layoutY="116.0" strokeType="OUTSIDE" strokeWidth="0.0" text="Kimsiz?">
+ <font>
+ <Font size="36.0"/>
+ </font>
+ </Text>
+ <VBox alignment="TOP_CENTER" layoutY="172.0" prefHeight="150.0" prefWidth="600.0" spacing="20.0">
+ <Button mnemonicParsing="false" onAction="#onNotaryButtonClick" prefHeight="26.0" prefWidth="149.0" text="Notarius"/>
+ <Button mnemonicParsing="false" onAction="#onHelperButtonClick" text="Notarius yordamchisi"/>
+ <Button mnemonicParsing="false" onAction="#onMonitorButtonClick" prefHeight="26.0" prefWidth="149.0" text="Monitor"/>
+ <Button mnemonicParsing="false" onAction="#onTabletButtonClick" prefHeight="26.0" prefWidth="149.0" text="Planshet"/>
+ </VBox>
+</AnchorPane>
diff --git a/src/main/resources/com/mavlushechka/notaryqueue/monitor.fxml b/src/main/resources/com/mavlushechka/notaryqueue/monitor.fxml
new file mode 100644
index 0000000..473b7a5
--- /dev/null
+++ b/src/main/resources/com/mavlushechka/notaryqueue/monitor.fxml
@@ -0,0 +1,29 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<?import javafx.scene.control.ListView?>
+<?import javafx.scene.layout.AnchorPane?>
+<?import javafx.scene.text.Font?>
+<?import javafx.scene.text.Text?>
+
+<AnchorPane maxHeight="-Infinity" maxWidth="-Infinity" minHeight="-Infinity" minWidth="-Infinity" prefHeight="720.0" prefWidth="1280.0" xmlns="http://javafx.com/javafx/18" xmlns:fx="http://javafx.com/fxml/1" fx:controller="com.mavlushechka.notaryqueue.controller.HelperController">
+ <ListView fx:id="waitingClients" layoutX="20.0" layoutY="35.0" prefHeight="500.0" prefWidth="400.0" />
+ <ListView fx:id="processingClients" layoutX="440.0" layoutY="35.0" prefHeight="500.0" prefWidth="400.0" />
+ <ListView fx:id="readyClients" layoutX="860.0" layoutY="35.0" prefHeight="500.0" prefWidth="400.0" />
+ <Text layoutX="171.0" layoutY="29.0" strokeType="OUTSIDE" strokeWidth="0.0" text="Kutilmoqda">
+ <font>
+ <Font size="18.0" />
+ </font></Text>
+ <Text layoutX="583.0" layoutY="28.0" strokeType="OUTSIDE" strokeWidth="0.0" text="Bajarilmoqda">
+ <font>
+ <Font size="18.0" />
+ </font></Text>
+ <Text layoutX="1032.0" layoutY="28.0" strokeType="OUTSIDE" strokeWidth="0.0" text="Tayyor">
+ <font>
+ <Font size="18.0" />
+ </font></Text>
+ <Text fx:id="roomInvitationText" layoutX="59.0" layoutY="640.0" strokeType="OUTSIDE" strokeWidth="0.0" text="01. Shahzoda notarius xonasiga kiring!">
+ <font>
+ <Font size="64.0" />
+ </font>
+ </Text>
+</AnchorPane>
diff --git a/src/main/resources/com/mavlushechka/notaryqueue/notary.fxml b/src/main/resources/com/mavlushechka/notaryqueue/notary.fxml
new file mode 100644
index 0000000..db61f6e
--- /dev/null
+++ b/src/main/resources/com/mavlushechka/notaryqueue/notary.fxml
@@ -0,0 +1,6 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<?import javafx.scene.layout.AnchorPane?>
+
+
+<AnchorPane maxHeight="-Infinity" maxWidth="-Infinity" minHeight="-Infinity" minWidth="-Infinity" prefHeight="400.0" prefWidth="600.0" xmlns="http://javafx.com/javafx/18"/>